-- RTASpeedLimiter
--
-- Version 1.0
-- Autor Ralf08
-- 
-- Change log:
-- 12.04.2015 / Ralf08 / release
-- 12.07.2015 / Ralf08 / small corrections



DrivableSpeedLimiter = {};

local DrivableSpeedLimiter_directory = g_currentModDirectory;
local checkvehicle
local strVehicle
local strInput
local FirstRun


source(Utils.getFilename("RTASpeedLimiter.lua", DrivableSpeedLimiter_directory));

function DrivableSpeedLimiter:load()
	self.RTA_D_maxSpeed, self.RTA_new = RTASpeedLimiter:check(self.configFileName)
	
	if self.RTA_D_maxSpeed ~= nil then
		self.motor.maxForwardSpeed = (self.RTA_D_maxSpeed + 3)/ 3.6
	else
		self.RTA_D_maxSpeed = self.motor.maxForwardSpeed * 3.6
	end;
end;

function DrivableSpeedLimiter:delete()
end;

function DrivableSpeedLimiter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DrivableSpeedLimiter:keyEvent(unicode, sym, modifier, isDown)
end;


function DrivableSpeedLimiter:update(dt)
			
	if self.isEntered and RTAhud and RTA_saved then
		if InputBinding.hasEvent(InputBinding.RTASpeedLimiterkey1) then
			strInput = strInput + 5
		end;
		
		if InputBinding.hasEvent(InputBinding.RTASpeedLimiterkey2) then
			if strInput > 0 then
				strInput = strInput - 5
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.RTASpeedLimiterkey3) then
			if checkvehicle ~= self then
				if self.RTA_A_new ~= nil then
					table.remove(self.RTA_A_new, 1)
				end;
			end;
			DrivableSpeedLimiter:saveValue(self)
		end;
	end;
	
	if self.isEntered and RTAhud and RTA_saved == false then
		if InputBinding.hasEvent(InputBinding.RTASpeedLimiterkey3) then
			RTAhud = false
		end;
	end;
end;

function DrivableSpeedLimiter:updateTick(dt)
	if self.isEntered and RTAhud ~= true then
		if self.RTA_A_new ~= nil then
			DrivableSpeedLimiter:speedcheck(self)
		end;
	end;
end;

function DrivableSpeedLimiter:readStream(streamId, connection)
end;

function DrivableSpeedLimiter:writeStream(streamId, connection)
end;


function DrivableSpeedLimiter:onEnter()
	DrivableSpeedLimiter:speedcheck(self)
end;

function DrivableSpeedLimiter:onLeave()
	checkvehicle = nil
	strVehicle = nil
	strInput = nil
	checkvehicle = nil
	RTAhud = false
end;

function DrivableSpeedLimiter:saveValue(self)
	if checkvehicle == self then
		if strInput > 0 then
			checkvehicle.RTA_D_maxSpeed = strInput
			checkvehicle.motor.maxForwardSpeed = math.min((checkvehicle.RTA_D_maxSpeed + 3) / 3.6, checkvehicle.motor.maxForwardSpeed)
		end;
	else
		if strInput > 0 then
			checkvehicle.RTA_A_maxSpeed = strInput
			self.motor.maxForwardSpeed = math.min((checkvehicle.RTA_A_maxSpeed + 3) / 3.6, self.motor.maxForwardSpeed)
		end;
	end;
	RTASpeedLimiter:save(checkvehicle.configFileName, strInput)
	checkvehicle.RTA_new = nil
	checkvehicle = nil
	strVehicle = nil
	strInput = nil
	checkvehicle = nil
	RTAhud = false
	
end;

function DrivableSpeedLimiter:draw()
	if RTAhud and RTA_saved then
		g_currentMission:addHelpButtonText(g_i18n:getText("RTASpeedLimiterkey1"),InputBinding.RTASpeedLimiterkey1);
		g_currentMission:addHelpButtonText(g_i18n:getText("RTASpeedLimiterkey2"),InputBinding.RTASpeedLimiterkey2);
		g_currentMission:addHelpButtonText(g_i18n:getText("RTASpeedLimiterkey3"),InputBinding.RTASpeedLimiterkey3);
		setTextAlignment(RenderText.ALIGN_CENTER)
		renderText(0.5,0.5,0.05,strVehicle.."\nvMAX\n"..strInput.."km/h")
	end;
	if RTAhud and RTA_saved == false then
		g_currentMission:addHelpButtonText(g_i18n:getText("RTASpeedLimiterkey3"),InputBinding.RTASpeedLimiterkey3);
		setTextAlignment(RenderText.ALIGN_CENTER)
		renderText(0.5,0.5,0.05,g_i18n:getText("RTAerror1").."\n"..g_i18n:getText("RTAerror2"))
	end;
end;


function DrivableSpeedLimiter:speedcheck(self)
	RTAhud = false
	if RTA_saved then
		if self.RTA_new then
			self.RTA_D_maxSpeed, self.RTA_new = RTASpeedLimiter:check(self.configFileName)
			if self.RTA_new then
				strVehicle = DrivableSpeedLimiter:name(self.configFileName)
				strInput = 0
				RTAhud = true
				checkvehicle = self
			else
				if self.RTA_D_maxSpeed ~= nil then
					self.motor.maxForwardSpeed = math.min((self.RTA_D_maxSpeed + 3) / 3.6, self.motor.maxForwardSpeed)
				else
					self.RTA_D_maxSpeed = self.motor.maxForwardSpeed * 3.6
				end;
			end;
		end;
		if self.RTA_A_new ~= nil and RTAhud ~= true then
			local slave = nil
			for i, v in pairs(g_currentMission.vehicles) do
				if g_currentMission.vehicles[i].id == self.RTA_A_new[1] then
					slave = g_currentMission.vehicles[i]
					break;
				end;
			end;
		
			if slave ~= nil then
				slave.RTA_A_maxSpeed, slave.RTA_new = RTASpeedLimiter:check(slave.configFileName)
				if slave.RTA_new then
					strVehicle = DrivableSpeedLimiter:name(slave.configFileName)
					strInput = 0
					RTAhud = true
					checkvehicle = slave
				else
					if slave.RTA_A_maxSpeed ~= nil then
						self.motor.maxForwardSpeed = math.min((slave.RTA_A_maxSpeed + 3) / 3.6, self.motor.maxForwardSpeed)
					end;
				end;
			end;
		end;
	else
		if FirstRun == nil then
			FirstRun = false
			RTAhud = true
		end;
	end;	
end;

function DrivableSpeedLimiter:name(strName)
	while true do
		if string.find(strName,"/") ~= nil then
			strName = string.sub(strName, string.find(strName,"/")+1)
		else
			strName = string.sub(strName, 1, string.len(strName)-4)
			break;
		end;
	end;
	strName = string.upper(strName)
	return strName
end;

function DrivableSpeedLimiter:detachImplement(implementIndex)
	checkvehicle = nil
	strVehicle = nil
	strInput = nil
	checkvehicle = nil
	RTAhud = false
end;